#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/Xlocale.h>

XIMStyle SelectInputStyle ();
XIC CreateInputContext ();

main()
{
   Display *d;
   Window p, w1, w2, w;
   GC gc;
   XFontSet fs;
   char **miss, *def;
   int n_miss;
   XIM im;
   XIMStyle style;
   XIC ic;
   XEvent e;
   long mask;
   KeySym sym;
   Status st;
   char *buf;
   int blen = 1024, len;
   char str1[1024], str2[1024], *str;
   int slen1 = 0, slen2 = 0, *slen;
   int i;

   setlocale (LC_ALL, "");
   d = XOpenDisplay (NULL);
   if (XSupportsLocale () == False) exit (1);

   if (XSetLocaleModifiers ("") == NULL)
     { fprintf (stderr, "Cannot set locale modifiers.\n");
       exit (1);
     }
   if ((im = XOpenIM (d, NULL, NULL, NULL)) == NULL)
     { fprintf (stderr, "Cannot open input method.\n");
       exit (1);
     }

   p = XCreateSimpleWindow (d, RootWindow (d, 0), 400, 400,
                            400, 120, 2, 0, 1);
   w1 = XCreateSimpleWindow (d, p,  20, 20, 160, 40, 2, 0, 1);
   w2 = XCreateSimpleWindow (d, p, 220, 20, 160, 40, 2, 0, 1);

   fs = XCreateFontSet (d, "-*-*-medium-r-normal--14-*",
                        &miss, &n_miss, &def);
   gc = XCreateGC (d, p, 0, 0);

   style = SelectInputStyle (im);

   ic = CreateInputContext (im, style, fs, p);


   XGetICValues (ic, XNFilterEvents, &mask, NULL);
   XSelectInput (d, w1, ExposureMask | KeyPressMask
                 | EnterWindowMask | LeaveWindowMask | mask);
   XSelectInput (d, w2, ExposureMask | KeyPressMask
                 | EnterWindowMask | LeaveWindowMask | mask);
   XSelectInput (d, p, StructureNotifyMask);

   XMapWindow (d, p);  XMapWindow (d, w1);  XMapWindow (d, w2);
   buf = malloc (blen);

   while (1) {
     XNextEvent (d, &e);
     if (XFilterEvent (&e, None))  continue;

     if (e.xany.window == w1)
       { w = w1;  str = str1;  slen = &slen1; }
     else if (e.xany.window == w2)
       { w = w2;  str = str2;  slen = &slen2; }

     switch (e.type)
      {
       case EnterNotify:
         XSetICValues (ic, XNFocusWindow, w, NULL);
         XSetICFocus (ic);
         if (style & XIMPreeditPosition)
           MoveInputPosition (ic, fs, str, *slen);
         break;
       case LeaveNotify:
         XUnsetICFocus (ic);  break;

       case KeyPress:
         len = XmbLookupString (ic, &e, buf, blen, &sym, &st);
         if (st == XBufferOverflow)
           { buf = realloc (buf, len);  blen = len;
             len = XmbLookupString (ic, &e, buf, blen, &sym, &st);
           }
         switch (st)
           { case XLookupBoth:
             case XLookupChars:
                    for (i=0; i < len; i++)  str[(*slen)++] = buf[i];
                    if (style & XIMPreeditPosition)
                      MoveInputPosition (ic, fs, str, *slen);
                    XClearWindow (d, w);
                    XmbDrawString (d, w, fs, gc, 10, 30, str, *slen);
                    break;
           }
         break;

       case Expose:
         if (e.xexpose.count == 0)
           XmbDrawString (d, w, fs, gc, 10, 30, str, *slen);
         break;

       case ConfigureNotify:
         if (e.xany.window != p)  break;

         if (style & XIMPreeditArea)
           SetGeometry (ic, e, XIMPreeditArea, XNPreeditAttributes);
         if (style & XIMStatusArea)
           SetGeometry (ic, e, XIMStatusArea, XNStatusAttributes);

         XMoveResizeWindow (d, w1, 20, 20,
                            e.xconfigure.width / 2 - 40, 40);
         XMoveResizeWindow (d, w2, e.xconfigure.width / 2 + 20, 20,
                            e.xconfigure.width / 2 - 40, 40);
         break;
       }
   }
}

XIMStyle SelectInputStyle (im)
XIM im;
{
   static XIMStyle preedit[] = {XIMPreeditPosition, XIMPreeditArea,
                                XIMPreeditNothing, NULL };
   static XIMStyle status[] = {XIMStatusArea, XIMStatusNothing, NULL};
   XIMStyles *im_styles;
   int i, j, k;

   XGetIMValues (im, XNQueryInputStyle, &im_styles, NULL);

   i = 0;
   while (preedit[i] != NULL)
     {
       j = 0;
       while (status[j] != NULL)
         {
           for (k = 0; k < im_styles->count_styles; k++)
             {
               if ((preedit[i] & im_styles->supported_styles[k]) &&
                     (status[j] & im_styles->supported_styles[k]))
                 return (im_styles->supported_styles[k]);
             }
           j++;
         }
       i++;
     }

   fprintf (stderr, "Input Style does not match.\n");
   return (NULL);
}

XIC CreateInputContext (im, style, fs, p)
XIM im;
XIMStyle style;
XFontSet fs;
Window p;
{
   XIC ic;
   XVaNestedList list;
   XPoint spot;

   spot.x = 10;
   spot.y = 30;
   list = XVaCreateNestedList (0, XNFontSet, fs,
                                  XNSpotLocation, &spot,
                                  NULL);
   ic = XCreateIC (im,
                   XNInputStyle, style,
                   XNClientWindow, p,
                   XNPreeditAttributes, list,
                   XNStatusAttributes, list,
                   NULL);
   if (ic == NULL)
     { fprintf (stderr, "Cannot create input context.\n");
       exit (1);
     }

   XFree (list);
   return (ic);
}

MoveInputPosition (ic, fs, str, slen)
XIC ic;  XFontSet fs;  char *str;  int slen;
{
   XPoint spot;  XVaNestedList list;

   spot.x = 10 + XmbTextEscapement (fs, str, slen);
   spot.y = 30;
   list = XVaCreateNestedList (0, XNSpotLocation, &spot, NULL);
   XSetICValues (ic, XNPreeditAttributes, list, NULL);
   XFree (list);
}

SetGeometry (ic, e, style, attr)
XIC ic;  XEvent e;  XIMStyle style;  char *attr;
{
   XRectangle area, *area2;  XVaNestedList list;

   area.width = e.xconfigure.width - 20;
   area.height = 18;
   list = XVaCreateNestedList (0, XNAreaNeeded, &area, NULL);
   XSetICValues (ic, attr, list, NULL);
   XFree (list);

   list = XVaCreateNestedList (0, XNAreaNeeded, &area2, NULL);
   XGetICValues (ic, attr, list, NULL);
   XFree (list);

   area2->x = 10;
   if (style == XIMPreeditArea)
     area2->y = e.xconfigure.height - area2->height * 2 - 4;
   else if (style == XIMStatusArea)
     area2->y = e.xconfigure.height - area2->height - 2;

   list = XVaCreateNestedList (0, XNArea, area2, NULL);
   XSetICValues (ic, attr, list, NULL);
   XFree (list);
   XFree (area2);
}
